diff --git a/game/client/.gitignore b/game/client/.gitignore
index cc46de012..c5dcc39b7 100644
--- a/game/client/.gitignore
+++ b/game/client/.gitignore
@@ -1,3 +1,3 @@
 build
-/dumpTextures/
-logs
\ No newline at end of file
+logs
+dumpTextures
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index f13f5ef15..2eac4866e 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -190,6 +190,7 @@ import net.minecraft.core.world.save.SaveConverters;
 import net.minecraft.core.world.save.SaveFormats;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
 import org.slf4j.Logger;
+import org.useless.dragonfly.data.entity.mojang.EntityGeometryMojangData;
 
 
 import static net.minecraft.core.Global.CURRENT_SAVE_VERSION;
@@ -532,6 +533,7 @@ public class Minecraft
         }
 
         this.texturePackList.init();
+        EntityGeometryMojangData.Cache.reload(this.texturePackList);
 
         TooltipElement.reloadStyles(this.texturePackList);
         SoundRepository.initialize(this);
@@ -550,7 +552,6 @@ public class Minecraft
         BlockModelDispatcher.getInstance();
         ItemModelDispatcher.getInstance();
 
-        EntityRenderDispatcher.instance.itemRenderer = new ItemRenderer(this);
         loadScreen();	// Update loading screen so it doesn't say no response
 
         LOGGER.info("Initializing input");
diff --git a/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java b/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
index 510a0610c..086c36f1f 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
@@ -30,109 +30,112 @@ public class ClientSkinVariantList extends SkinVariantList {
 
 	private final Map<String, @Nullable EntityVariants> variantProcessorMap = new HashMap<>();
 
-	public ClientSkinVariantList(Minecraft minecraft) {
-		this.mc = minecraft;
-	}
+	public ClientSkinVariantList(final Minecraft minecraft) {
+        super();
+        this.mc = minecraft;
+    }
 
 
-	public void refresh(List<Throwable> errors) {
-		variantProcessorMap.clear();
+	public void refresh(final List<Throwable> errors) {
+        this.variantProcessorMap.clear();
 	}
 
 
 	@Override
-	public @NotNull String getSkinReference(@Nullable String variantJsonPath, @NotNull String defaultKey, int skinIndex) {
-		EntityVariants variants = getEntityVariants(variantJsonPath);
+	public @NotNull String getSkinReference(@Nullable final String variantJsonPath, @NotNull final String defaultKey, final int skinIndex) {
+		final EntityVariants variants = getEntityVariants(variantJsonPath);
 		if (variants == null) return defaultKey;
 		return variants.getKeyFromIndex(skinIndex);
 	}
 
-	protected @Nullable EntityVariants getEntityVariants(@Nullable String variantJsonPath) {
+	protected @Nullable EntityVariants getEntityVariants(@Nullable final String variantJsonPath) {
 		try {
 			if (!Minecraft.getMinecraft().gameSettings.mobVariants.value) return null;
 			if (variantJsonPath == null) return null;
-			if (!variantProcessorMap.containsKey(variantJsonPath)) {
-				loadJson(variantJsonPath);
+			if (this.variantProcessorMap.containsKey(variantJsonPath)) {
+				return this.variantProcessorMap.get(variantJsonPath);
 			}
-			return variantProcessorMap.get(variantJsonPath);
-		} catch (Exception e) {
+			final EntityVariants variants = loadJson(variantJsonPath);
+			this.variantProcessorMap.put(variantJsonPath, variants);
+			return variants;
+		} catch (final Exception e) {
 			LOGGER.error("Failed to load json at '{}'!", variantJsonPath, e);
-			variantProcessorMap.put(variantJsonPath, null); // Null the path after an exception happened trying to load it, prevents exception spam
+            this.variantProcessorMap.put(variantJsonPath, null); // Null the path after an exception happened trying to load it, prevents exception spam
 		}
 		return null;
 	}
 
 	@Override
-	public int nextSkinVariant(@Nullable String variantJsonPath, int skinIndex) {
-		EntityVariants variants = getEntityVariants(variantJsonPath);
+	public int nextSkinVariant(@Nullable final String variantJsonPath, final int skinIndex) {
+		final EntityVariants variants = getEntityVariants(variantJsonPath);
 		if (variants == null) return skinIndex;
 		return variants.getNextVariant(skinIndex);
 	}
 
-	public void loadJson(String variantJsonPath) {
-		load: try (InputStream stream = mc.texturePackList.getResourceAsStream(variantJsonPath)){
-			if (stream == null) return;
-			String jsonString;
+	protected @Nullable EntityVariants loadJson(final String variantJsonPath) {
+		load: try (final InputStream stream = this.mc.texturePackList.getResourceAsStream(variantJsonPath)){
+			if (stream == null) return null;
+			final String jsonString;
 			try {
 				jsonString = StringUtils.readInputString(stream);
-			} catch (Exception e) {
+			} catch (final Exception e) {
                 LOGGER.error("Failed to parse '{}' as a Json String!", variantJsonPath, e);
 				break load;
 			}
             try {
-                JsonObject variantObject = JsonParser.parseString(jsonString).getAsJsonObject();
+                final JsonObject variantObject = JsonParser.parseString(jsonString).getAsJsonObject();
 				if (variantObject.has("skins")) {
-					JsonElement skins = variantObject.get("skins");
+					final JsonElement skins = variantObject.get("skins");
 					if (skins.isJsonPrimitive()) {
-						variantProcessorMap.put(variantJsonPath, new EntityVariants(skins.getAsInt()));
-						return;
+						return new EntityVariants(skins.getAsInt());
 					} else if (skins.isJsonArray()) {
-						List<EntityVariants.VariantEntry> variants = new ArrayList<>();
-						JsonArray arr = skins.getAsJsonArray();
-						for (JsonElement e: arr) {
-							JsonObject entryObj = e.getAsJsonObject();
-							String textureReference = entryObj.get("texture").getAsString();
+						final List<EntityVariants.VariantEntry> variants = new ArrayList<>();
+						final JsonArray arr = skins.getAsJsonArray();
+						for (final JsonElement e: arr) {
+							final JsonObject entryObj = e.getAsJsonObject();
+							final String textureReference = entryObj.get("texture").getAsString();
 							double weight = 1;
 							if (entryObj.has("weight")) {
 								weight = entryObj.get("weight").getAsDouble();
 							}
 							variants.add(new EntityVariants.VariantEntry(textureReference, weight));
 						}
-						variantProcessorMap.put(variantJsonPath, new EntityVariants(variants));
-						return;
+						return new EntityVariants(variants);
 					} else {
                         LOGGER.error("Error at {}: value 'skins' must either be a integer or an array!", variantJsonPath);
 						break load;
 					}
 				}
-            } catch (JsonParseException e) {
+            } catch (final JsonParseException e) {
                 LOGGER.error("Failed to parse Json at {}", variantJsonPath, e);
             }
-        } catch (IOException e) {
+        } catch (final IOException e) {
             LOGGER.error("IO Exception while trying to read '{}'!", variantJsonPath, e);
 			break load;
         }
-		variantProcessorMap.put(variantJsonPath, null);
+		return null;
     }
 
 	protected static class EntityVariants {
+		private final String @Nullable [] indexedSkins;
+		private final VariantEntry @Nullable [] variantEntries;
 
-		private final VariantEntry[] variantEntries;
-		private final int skins;
-
-		public EntityVariants(int skins) {
+		public EntityVariants(final int skins) {
 			if (skins <= 0) throw new IllegalArgumentException("Skins number attribute must be at-least 1!");
-			this.skins = skins;
+			this.indexedSkins = new String[skins];
+			for (int i = 0; i < this.indexedSkins.length; i++) {
+				this.indexedSkins[i] = Integer.toString(i);
+			}
 			this.variantEntries = null;
 		}
 
-		public EntityVariants(List<VariantEntry> entries) {
-			variantEntries = new VariantEntry[MAX_VARIANT_ID + 1];
-			this.skins = -1;
+		public EntityVariants(final List<VariantEntry> entries) {
+            this.variantEntries = new VariantEntry[MAX_VARIANT_ID + 1];
+			this.indexedSkins = null;
 			double accWeight = 0;
 			entries.sort(Comparator.comparingDouble(o -> -o.weight));
 
-			for (VariantEntry e : entries) {
+			for (final VariantEntry e : entries) {
 				accWeight += e.weight;
 			}
 
@@ -140,57 +143,59 @@ public class ClientSkinVariantList extends SkinVariantList {
 			main:
 			{
 				int pointer = 0;
-				for (VariantEntry e : entries) {
+				for (final VariantEntry e : entries) {
 					int amount = MathHelper.floor((e.weight / accWeight) * MAX_VARIANT_ID);
 					if (amount < 1) amount = 1;
 
 					for (int i = 0; i < amount; i++) {
-						variantEntries[pointer] = e;
+                        this.variantEntries[pointer] = e;
 						pointer++;
-						if (pointer > variantEntries.length - 1) break main;
+						if (pointer > this.variantEntries.length - 1) break main;
 					}
 				}
 
-				VariantEntry last = entries.get(0);
-				while (pointer < variantEntries.length) {
-					variantEntries[pointer] = last;
+				final VariantEntry last = entries.get(0);
+				while (pointer < this.variantEntries.length) {
+                    this.variantEntries[pointer] = last;
 					pointer++;
 				}
 			}
 
 
-			Map<String, Integer> counts = new HashMap<>();
-			for (VariantEntry e : variantEntries) {
+			final Map<String, Integer> counts = new HashMap<>();
+			for (final VariantEntry e : this.variantEntries) {
 				counts.putIfAbsent(e.textureKey, 0);
 				counts.put(e.textureKey, counts.get(e.textureKey) + 1);
 			}
 		}
 
-		public String getKeyFromIndex(int index) {
-			if (variantEntries != null) {
-				return variantEntries[index].textureKey;
+		public @NotNull String getKeyFromIndex(final int index) {
+			if (this.variantEntries != null) {
+				return this.variantEntries[index].textureKey;
 			}
-			return String.valueOf(index % skins);
+			assert this.indexedSkins != null;
+			return this.indexedSkins[index % this.indexedSkins.length];
 		}
 
-		public int getNextVariant(int index) {
-			if (variantEntries != null) {
-				VariantEntry currentEntry = variantEntries[index];
-				for (int i = 1; i < variantEntries.length; i++) {
-					if (currentEntry != variantEntries[(index + i)%variantEntries.length]) {
-						return (index + i)%variantEntries.length;
+		public int getNextVariant(final int index) {
+			if (this.variantEntries != null) {
+				final VariantEntry currentEntry = this.variantEntries[index];
+				for (int i = 1; i < this.variantEntries.length; i++) {
+					if (currentEntry != this.variantEntries[(index + i)% this.variantEntries.length]) {
+						return (index + i)% this.variantEntries.length;
 					}
 				}
 				return index;
 			} else {
-				return (index + 1) % skins;
+                assert this.indexedSkins != null;
+                return (index + 1) % this.indexedSkins.length;
 			}
 		}
 
 		protected static class VariantEntry {
 			public final String textureKey;
 			public final double weight;
-			public VariantEntry(String key, double weight) {
+			public VariantEntry(final String key, final double weight) {
 				this.textureKey = key;
 				this.weight = weight;
 			}
diff --git a/game/client/src/main/java/net/minecraft/client/entity/particle/Particle.java b/game/client/src/main/java/net/minecraft/client/entity/particle/Particle.java
index e1a665baf..d7ba95d57 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/particle/Particle.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/Particle.java
@@ -35,7 +35,7 @@ public class Particle extends Entity {
      * @param ya The particle's initial Y velocity.
      * @param za The particle's initial Z velocity.
      */
-    public Particle(World world, double x, double y, double z, double xa, double ya, double za) {
+    public Particle(@NotNull final World world, double x, double y, double z, double xa, double ya, double za) {
         super(world);
         setSize(0.2F, 0.2F);
         this.heightOffset = this.bbHeight / 2.0F;
diff --git a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleFirefly.java b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleFirefly.java
index d4ed48f6f..935210f93 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleFirefly.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleFirefly.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public class ParticleFirefly extends Particle {
     private float sinTimer = 0;
@@ -23,11 +24,11 @@ public class ParticleFirefly extends Particle {
     private final float oG;
     private final float oB;
 
-    public ParticleFirefly(World world, double x, double y, double z, double xa, double ya, double za, int type) {
+    public ParticleFirefly(@NotNull final World world, double x, double y, double z, double xa, double ya, double za, int type) {
         this(world, x, y, z, xa, ya, za, 1.0F, type);
     }
 
-    public ParticleFirefly(World world, double x, double y, double z, double xa, double ya, double za, float scale, int type) {
+    public ParticleFirefly(@NotNull final World world, double x, double y, double z, double xa, double ya, double za, float scale, int type) {
         super(world, x, y, z, 0.0D, 0.0D, 0.0D);
         this.xd = 0.01D;
         this.yd = 0.01D;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index 9901455d8..0e275291a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -451,14 +451,6 @@ public abstract class ScreenContainerAbstract extends Screen
 			}
 		}
 		
-		// Equip armor
-		if(slot != null && itemInSlot instanceof IArmorItem) {
-			if(mouseButton == 1 && shiftPressed) {
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.EQUIP_ARMOR, new int[] {slot.index}, mc.thePlayer);
-				return;
-			}
-		}
-		
 		// ContainerInventory Interactions (Grabbed Item)
 		if(slot != null && slot.allowItemInteraction() && grabbedItem != null && grabbedItem.getItem().hasInventoryInteraction()) {
 			if(mouseButton == 1) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
index 2662f8106..eb46eeb9a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
@@ -10,6 +10,7 @@ import net.minecraft.client.render.*;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.entity.Entity;
@@ -50,7 +51,7 @@ public class GuidebookPageMob
         this.mobInfo = mobInfo;
         Mob example = null;
         try {
-            example = (Mob) mobClass.getConstructor(World.class).newInstance((Object)null);
+            example = (Mob) mobClass.getConstructor(World.class).newInstance(WorldClient.EMPTY_WORLD);
         } catch (Exception e) {
             LOGGER.error("Failed to create example instance of mob '{}'!", mobClass.getSimpleName(), e);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index 3e9af8a67..61e9785a2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -80,6 +80,8 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
     protected boolean rotateToCamera = true;
     public ScreenModelViewer(){
         this.mc = Minecraft.getMinecraft();
+        mc.currentWorld.loadedEntityList.clear();
+        mc.currentWorld.loadedTileEntityList.clear();
         mc.thePlayer.absMoveTo(0.5, 64.5, 0.5, 180, 0);
         mc.thePlayer.noPhysics = true;
         mc.textureManager.refreshTexturesAndDisplayErrors();
@@ -136,7 +138,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
         buttonCategory.setOnValueChanged(() -> buttonCategory.displayString = i18n.translateKey(currentCategory.getCategoryNameKey()));
 
         buttonReloadTextures = new ListenerButtonElement(12, 21, height - 20, 98, 20, i18n.translateKey("gui.model_viewer.button.reload_textures"));
-        buttonReloadTextures.setActionListener(() -> mc.textureManager.refreshTexturesAndDisplayErrors());
+        buttonReloadTextures.setActionListener(() -> mc.texturePackList.refresh());
         buttonOpenScreenshotFolder = (ListenerButtonElement) new ListenerButtonElement(30, buttonReloadTextures.getWidth() + buttonReloadTextures.getX() + 1, buttonReloadTextures.getY(), 20, 20, "")
             .setTextures("minecraft:gui/misc/button_folder", "minecraft:gui/misc/button_folder_highlighted", "minecraft:gui/misc/button_folder");
         buttonOpenScreenshotFolder.setActionListener(() -> FileOpener.open(new File(mc.getMinecraftDir(), "")));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index c473d621b..08bc1cede 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -345,7 +345,7 @@ public abstract class OptionsPages
             .withComponent(new OptionsCategory("gui.options.page.debug.category.utility")
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.model_viewer", () -> {
                                    mc.playerController = new PlayerControllerSP(mc);
-                                   mc.changeWorld(new WorldClient(), "Loading Model Viewer");
+                                   mc.changeWorld(WorldClient.EMPTY_WORLD, "Loading Model Viewer");
                                    mc.displayScreen(new ScreenModelViewer());}) {
                                    @Override
                                    public void render(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
diff --git a/game/client/src/main/java/net/minecraft/client/input/controller/Joystick.java b/game/client/src/main/java/net/minecraft/client/input/controller/Joystick.java
index d34d9bbfe..c4d8ecdd3 100644
--- a/game/client/src/main/java/net/minecraft/client/input/controller/Joystick.java
+++ b/game/client/src/main/java/net/minecraft/client/input/controller/Joystick.java
@@ -41,13 +41,22 @@ public class Joystick{
 		float x = this.joystickListener.getValue(xAxis);
 		float y = this.joystickListener.getValue(yAxis);
 
-		float length = (float) Math.sqrt(x * x + y * y);
+		float magnitude = (float) Math.sqrt(x * x + y * y);
 		
-		boolean inDeadzone = length < deadzone.value;
+		boolean inDeadzone = magnitude < deadzone.value;
 
 		if (inDeadzone) {
 			x = 0.0f;
 			y = 0.0f;
+		} else {
+			float ux = x / magnitude;
+			float uy = y / magnitude;
+			float dx = ux * deadzone.value;
+			float dy = uy * deadzone.value;
+			float px = (x - dx) / (1.0f - Math.abs(dx));
+			float py = (y - dy) / (1.0f - Math.abs(dy));
+			x = px;
+			y = py;
 		}
 
 		this.x = x;
